<template>

    <div class="movies_content">
        <div class="search">
            <my-select v-model="selectedSort" :options="sortOptions"></my-select>
            <my-input v-model="search"/>
        </div>
        <ul style="padding-left: 0">
            <li class="movies_list">
                <a class="movies_item" v-for="(movie,index) in paginatedMovie" :key="index"
                   @click="getSingleInfo(movie)">
                    <div class="movies_info">
                        <div><img class="movies_img" :src="movie.medium_cover_image" alt="img"></div>
                        <div class="info_content">
                            <h2>{{movie.title}}</h2>
                            <span>{{movie.year}}</span>
                            <p>Raiting: {{movie.rating}}</p>
                            <p>Language:{{movie.language}}</p>
                            <span class="movies_genres" v-for="genres in movie.genres" :key="genres">{{genres}}</span>
                        </div>
                    </div>
                    <p>{{movie.summary.slice(0,200)}}...</p>
                </a>
            </li>
        </ul>
        <ul class="pagination">
            <li v-for="pageNumber in totalPages" :key="pageNumber" @click="changePage(pageNumber)">{{ pageNumber }}</li>
        </ul>
    </div>

</template>

<script>
    import MySelect from "../components/Ui/MySelect";
    import MyInput from "../components/Ui/MyInput";
    import axios from 'axios'
    import {mapActions, mapGetters} from "vuex";

    export default {
        name: "MoviesPage",
        components: {MyInput, MySelect},
        data: () => ({
            exe: [],
            search:'',
            selectedSort: '',
            movies: [],
            singleMovie: '',
            paginate: [],
            page: 1,
            limit: 4,
            totalPages: 0,
            sortOptions: [
                {value: 'title', name: 'По названию'},
                {value: 'summary', name: 'По цодержимому'}
            ],
        }),
        methods: {

            async fetchMovie() {
                try {
                    const response = await axios.get('https://yts.mx/api/v2/list_movies.json', {
                        params: {
                            _page: this.page,
                            _limit: this.limit
                        }

                    });
                    this.movies = response.data.data.movies;
                    this.totalPages = Math.ceil(response.data.data.limit / this.limit);

                } catch (e) {
                    alert('Ошибка');

                }
            },

            changePage(pageNumber) {
                this.page = pageNumber;
                this.fetchMovie();

            },
            searchQuery() {
                return this.movies.filter(movie => {
                    return movie.title.toLowerCase().includes(this.search.toLowerCase())
                })
            },
            getSingleInfo(item) {
                this.$router.push({path: `/movies/${item.id}`})
            }
        },
        watch: {
            selectedSort(newValue) {
                this.movies.sort((movie1, movie2) => {
                    return movie1[newValue]?.localeCompare(movie2[newValue])

                })
            },
        },
        computed: {

            paginatedMovie() {
                let from = (this.page - 1) * this.limit;
                let to = from + this.limit;
                return this.movies.slice(from, to);
            }
        },

        mounted() {
            this.fetchMovie();
        }
    }
</script>

<style lang="scss">
    .movies_content {
        max-width: 1280px;
        width: 100%;
        margin: 0 auto;

        .search {
            display: flex;
            align-items: center;
            margin-top: 30px;
            margin-bottom: 30px;
        }

        .movies_list {
            display: flex;
            justify-content: space-between;
            flex-wrap: wrap;

            .movies_item {
                width: 45%;
                min-height: 320px;
                border: 1px solid #ffffff;
                border-radius: 5px;
                box-shadow: 4px 4px 8px 0 rgb(34 60 80 / 20%);
                list-style-type: none;
                display: inline-block;
                margin-bottom: 15px;
                background: #ffffff;
                padding: 10px;
                color: grey;
                transition: all .2s ease-in-out;

                &:hover {
                    cursor: pointer;

                    transform: scale(1.01);
                }

                .movies_info {
                    display: flex;

                    .info_content {
                        margin-left: 20px;
                        color: grey;

                        .movies_genres {
                            margin-right: 10px;
                        }
                    }
                }
            }
        }

        .pagination {
            display: flex;
            justify-content: center;
            padding-left: 0;
            list-style-type: none;
            padding-bottom: 15px;

            li {
                margin-left: 5px;
                padding: 5px 13px;
                border: 1px solid #4ebf4e;
                background-color: #ffffff;
                border-radius: 3px;
                color: grey;

                &:hover {
                    cursor: pointer;
                    opacity: .6;
                }
            }
        }
    }

</style>